#include <stdio.h>
typedef double gr_type;

struct gr_xy
{
  gr_type x;
  gr_type y;
};

struct std_list 
{
//  struct gr_xy xy;
  gr_type c;
  gr_type r;
  gr_type perim;
  short int id;
  short int id2;
  short int id3;
  char orient;
};

typedef struct ipix_ptr 
{
  unsigned int ipix;;
  struct std_list *ptr;  
} ipix_ptr;


struct obs_list 
{
//  struct gr_xy xy;
  gr_type c;
  gr_type r;
  gr_type e_c;
  gr_type e_r;
  gr_type perim;
  char orient;
  short int id;
  short int id2;
  short int id3;

  struct std_list *matched_ptr;
};



struct three_ints
{
short int l1;
short int l2;
short int l3;
};

typedef struct double_and_char
{
	double ratio;
	char flag;
} double_and_char;

typedef struct gr_matrix 
{
  gr_type t[2];
  gr_type b[2];
} gr_matrix;

typedef struct gr_vector 
{
  gr_type t[1];
  gr_type b[1];
} gr_vector;


int run_groth(char *fits_filename, char *obs_list_filename,
               char *std_list_filename, gr_type ra_cen, gr_type dec_cen,
               gr_type eps, gr_type *crval, gr_type *crpix, gr_type *cd,
               int nobsstars, int nstdstars, char use_wcs);

void get_new_wcs(gr_type scale, gr_matrix m, gr_vector c,
                 int xsize, int ysize, gr_matrix *cd,
                 gr_vector *pixref);

int get_transform(struct obs_list *olist, struct gr_xy *obs_xy,
                   struct gr_xy *std_xy, int nobstriangles, int nobsstars,
                   gr_matrix *m, gr_vector *v);

int match_lists(struct std_list *slist, struct obs_list *olist,
                 struct ipix_ptr *iptr, int nstdtriangles, int nobstriangles);

void process_obs_list (struct gr_xy *xy_data, int nstars, 
                       struct obs_list **out_data, int *ntriangles,
                       gr_type eps);

void process_std_list (struct gr_xy *xy_data, int nstars,
                       struct std_list **out_data, void **ipix_ptr_arr,
                       int *ntriangles);

void mode_hist(gr_type *data, int ndata, int *hist, int nhist, int *posl_out,
              int *posr_out);


void matrix_print(FILE *f, gr_matrix m); 
                 
void vector_print(FILE *f, gr_vector v);

int fix_wcs(char *filename, double *cd, double *crpix, double *crval);

int gmatch_get_image_size(char *filename, long *size);
inline int gr_type_compare(const void *a, const void *b);
inline int three_ints_compare(const void *a, const void *b);
inline int three_ints_compare1(const void *a, const void *b);
inline int ipix_compare(const void *a , const void * b);

inline int double_and_char_compare(const void *a, const void *b);


inline int three_ints_compare1(const void *a, const void *b);
void get_regression(gr_type a1, gr_type ax, gr_type ay, gr_type ax1,
                    gr_type axx, gr_type axx1, gr_type axy, gr_type ayx1,
                    gr_type ayy, gr_type *A, gr_type *B, gr_type *C);
void get_regression2(gr_type a1, gr_type ax, gr_type ay, gr_type ax1,
                     gr_type ay1, gr_type axx, gr_type axx1, gr_type axy1,
                     gr_type ayy, gr_type ayx1, gr_type ayy1, gr_type *A,
                     gr_type *B, gr_type *C, gr_type *D);
void get_regression2_1(gr_type a1, gr_type ax, gr_type ay, gr_type ax1,
                     gr_type ay1, gr_type axx, gr_type axx1, gr_type axy1,
                     gr_type ayy, gr_type ayx1, gr_type ayy1, gr_type *A,
                     gr_type *B, gr_type *C, gr_type *D);

void mode_hist1(double_and_char *data, int ndata, int *hist,
				int nhist, int *posl_out, int *posr_out);

