/*
 *   Copyright (C) 2005 Sergey Koposov
 * 
 * Author: Sergey Koposov, Sternberg Astronomical Institute
 * Email: math@sai.msu.ru 
 * http://lnfm1.sai.msu.ru/~math

  This file is part of GMATCH.

  GMATCH is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  GMATCH is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with GMATCH; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */


#include "fitsio.h"
#include <string.h>
#include "common.h"

#define __FERR fits_report_error(stderr, *status); if (*status) exit(*status)

/* Arguments 
 * ./fix_wcs filename.fits
 * After that the fix_wcs waits from the stdin the CD matrix, CRPIX and CRVAL
 * values.
 */
int main(int argc, char *argv[])
{
	char filename[256];
	double cd[4], crpix[2], crval[2];
	if (argc!=2)
	{
		fprintf(stderr, "Wrong arguments!\n");
		exit(1);
	}

	fscanf(stdin,"%lf %lf", cd, cd + 1);
	fscanf(stdin,"%lf %lf", cd + 2, cd + 3);
	fscanf(stdin,"%lf %lf", crpix, crpix + 1);
	fscanf(stdin,"%lf %lf", crval, crval + 1);
	
	strncpy(filename, argv[1], 255);

	fix_wcs(filename, cd, crpix, crval);
	return 0;

}

